--[[
  /ps start
  /ps startauction
  /ps stop
  /ps ignore/ignoreitem {link} 			//Ignore an item
  /ps ignorezone {Name}          		//Ignore a zone
  /ps alert {link}						//Pupup on drop
  ]]

-- Developing purposes------------------------
for i = 1, NUM_CHAT_WINDOWS do
	_G["ChatFrame"..i.."EditBox"]:SetAltArrowKeyMode(false)
end
----------------------------------------------
local PileSeller = _G.PileSeller
local psFrame, psEvents = CreateFrame("FRAME", "PileSeller_Frame"), {}
local canTrack = true
local waitingForItem = {false, "000000"}
PileSeller.selling = false
function psEvents:ADDON_LOADED(...)
	addoname = select(1,...)
	if addoname == "PileSeller" then
        if psSettings["hideMinimapButton"] then
            print("|cFF" .. PileSeller.color .. "Pile|rseller loaded. Type /pileseller o /ps to get into it!" )
        end
		if psItems then
			for i=1, #psItems do
				GetItemInfo(psItems[i])
			end
		end

		if psItemsSaved then
			for i=1, #psItemsSaved do
				GetItemInfo(psItemsSaved[i])
			end
		end
		PileSeller:PileSeller_MinimapButton_Reposition()
	end
end


function psEvents:CHAT_MSG_LOOT(...)
	--print(canTrack)
	local player = UnitName("player")
	local sender = select(5, ...)
	if canTrack and psSettings["trackSetting"] and (player == sender) then
		local item = select(1,...) -- This is the link of the item (with some crap text)
		item = PileSeller:getID(item)
		if item then
			if PileSeller:isSaved(item) then 
				message("|cFF" .. PileSeller.color .. "Found |r " .. select(2, GetItemInfo(item)) .. "|cFF" .. PileSeller.color .. ". yay!|r")
			elseif select(11, GetItemInfo(item)) > 0 then
                local keepTrasmog = psSettings["keepTrasmogs"] and PileSeller:CanTransmog(item)
                local keepBoE = psSettings["keepBoes"] and PileSeller:IsBoE(item)
                local keepItem = keepTrasmog or keepBoE
                if not keepItem then
                    if PileSeller.UIConfig then
                        PileSeller:addItem(item, psItems, PileSeller.UIConfig.toSellScroll.content)
                    else psItems[#psItems+1] = item end
                end
			end
		end
	end
end

function PileSeller:IsBoE(item)
    local f = CreateFrame('GameTooltip', 'PileSellerScanningTooltip', UIParent, 'GameTooltipTemplate')
    f:SetOwner(UIParent, 'ANCHOR_NONE') 
    f:SetItemByID(item)
    for i = 1, f:NumLines() do
        local t = _G["PileSellerScanningTooltipTextLeft" .. i]
        if t == ITEM_BIND_ON_EQUIP then return true end
    end
    return false
end

function PileSeller:CanTransmog(item)
    local canBeSource = select(3, GetItemTransmogrifyInfo(item))
    if not canBeSource then return false end
    if select(9, GetItemInfo(item)) == "INVTYPE_CLOAK" then return true end
    local class, subclass = select(6, GetItemInfo(item)), select(7, GetItemInfo(item))
    if class == ARMOR then
        local wearerTable = {                
            ["DEATHKNIGHT"] = select(5, GetAuctionItemSubClasses(2)),
            ["DRUID"] = select(3, GetAuctionItemSubClasses(2)),
            ["HUNTER"] = select(4, GetAuctionItemSubClasses(2)),
            ["MAGE"] = select(2, GetAuctionItemSubClasses(2)),
            ["MONK"] = select(3, GetAuctionItemSubClasses(2)),
            ["PALADIN"] = select(5, GetAuctionItemSubClasses(2)),
            ["PRIEST"] = select(2, GetAuctionItemSubClasses(2)),
            ["ROGUE"] = select(3, GetAuctionItemSubClasses(2)),
            ["SHAMAN"] = select(4, GetAuctionItemSubClasses(2)),
            ["WARLOCK"] = select(2, GetAuctionItemSubClasses(2)),
            ["WARRIOR"] = select(5, GetAuctionItemSubClasses(2))           
        }
        local playerClass = select(2, UnitClass("player"))
        if subclass == wearerTable[playerClass] then return true 
        else 
            if subclass == select(7, GetAuctionItemSubClasses(2)) then
                return playerClass == "WARRIOR" or playerClass == "SHAMAN" or playerClass == "PALADIN"
            end
            return false
        end
    elseif class == WEAPON then
        return PileSeller:IsWearable(item)       
    --elseif class == MISCELLANEOUS then
    --    if select(3, GetItemInfo(item)) == 4 then     THIS IS FOR TOKENS
    --        return PileSeller:IsWearable(item, true)       
    --    end
    else return false end    
end

function PileSeller:IsWearable(item)
    local playerClass = select(2, UnitClass("player"))     
    local f = CreateFrame('GameTooltip', 'PileSellerScanningTooltip', UIParent, 'GameTooltipTemplate')
    f:SetOwner(UIParent, 'ANCHOR_NONE') 
    f:SetItemByID(item) 
    local r,g,b = 0,0,0
    for i = 1, f:NumLines() do
        if _G["PileSellerScanningTooltipTextRight" .. i]:GetText() then
            r,g,b = _G["PileSellerScanningTooltipTextRight" .. i]:GetTextColor()
            if math.floor(r*256) == 255 and math.floor(g*256) == 32 and math.floor(b*256) == 32 then return false end
        end
        
        if _G["PileSellerScanningTooltipTextLeft" .. i]:GetText() then
            r,g,b = _G["PileSellerScanningTooltipTextLeft" .. i]:GetTextColor()
            if math.floor(r*256) == 255 and math.floor(g*256) == 32 and math.floor(b*256) == 32 then return false end
        end
    end
    local itemType = select(9, GetItemInfo(item))
    local isRanged = itemType == "INVTYPE_RANGED" or itemType == "INVTYPE_RANGEDRIGHT"
    if isRanged and (playerClass == "WARRIOR" or playerClass == "ROGUE") then
        return false
    end
    f:Hide()
    return true    
    --r,g,b = PileSellerScanningTooltipTextRight4:GetTextColor()
    
    --return not math.floor(r*256) == 255 and math.floor(g*256) == 32 and math.floor(b*256) == 32
end

local timer = 0
local Update_Interval = 1
local profit = 0
local Bag_Index = 0
local Last_Slot_Index = 1
local Index_Offset = 10
local broke = false
local function onUpdate(self,elapsed)
	timer = timer + elapsed
	if PileSeller.selling then
		if not PileSeller.sFrame:IsVisible() then PileSeller.sFrame:Show() end
	    if timer >= Update_Interval then
	    	l = GetContainerNumSlots(Bag_Index)
			for i = Last_Slot_Index, Last_Slot_Index + Index_Offset do
                if not canTrack then
                    local item = select(7, GetContainerItemInfo(Bag_Index, i))
                    local count = select(2, GetContainerItemInfo(Bag_Index, i))
                    if item and not string.find(item, "battlepet") then
                        local keepTrasmog = psSettings["keepTrasmogs"] and PileSeller:CanTransmog(PileSeller:getID(item))
                        local keepBoE = psSettings["keepBoes"] and PileSeller:IsBoE(PileSeller:getID(item))
                        local keepItem = keepTrasmog or keepBoE
                        if IsToSell(item) and not keepItem then
                                PileSeller.sFrame.sellingLbl:SetText("Sold item " .. item)
                                ShowMerchantSellCursor(1)
                                UseContainerItem(Bag_Index, i)
                                local cost = tonumber(select(11, GetItemInfo(item)))
                                local _p = cost * count
                                profit = profit + _p
                                local rtn = PileSeller:getProfitPerCoin(profit)
                                PileSeller.sFrame.profitLbl:SetText("Profit: " .. rtn)
                        end
                    end
                    Last_Slot_Index = i	
                else
                    broke = true
                    --print("You broke it you fool")
                    break
                end
			end
            if broke then
                PileSeller.selling = false
                Bag_Index = 0
                Last_Slot_Index = 1
                Index_Offset = 10
                profit = 0
                broke = false
			elseif Index_Offset ~= 10 then 
				-- Changing bag
				Bag_Index = Bag_Index + 1
				Last_Slot_Index = 1
				PileSeller.sFrame.statusBar:SetValue(Bag_Index)
				Index_Offset = 10
				if Bag_Index > NUM_BAG_SLOTS then
					PileSeller.selling = false
					Bag_Index = 0
					Last_Slot_Index = 1
					Index_Offset = 10
					psItems = {}
					profit = 0
					PileSeller.sFrame.statusBar.border:SetBackdropBorderColor(1,1,1)
					if psSettings["sellJunkSetting"] then
						PileSeller:SellJunk()
					end
				end
			elseif Last_Slot_Index + Index_Offset > l then
				Index_Offset = l - Last_Slot_Index 
			end			
	        timer = 0		    
	    end
	end
end
psFrame:SetScript("OnUpdate", onUpdate)


function PileSeller:getProfitPerCoin(profit)
	if profit == 0 then
		return "0|cFFFFD700g|r 0|cFFC0C0C0s|r 0|cFFCD7E32c|r"
	end
	local rtn = ""
	local gold = math.floor(profit / 100 / 100)
	if gold >= 1 then rtn = rtn .. gold .. "|cFFFFD700g|r " end

	local silver = math.floor((profit / 100) % 100)
	if silver >= 1 then rtn = rtn .. silver .. "|cFFC0C0C0s|r " end

	local copper = math.floor(profit % 100)
	if copper >= 1 then rtn = rtn .. copper .. "|cFFCD7E32c|r" end

	
	return rtn
end


function IsToSell(item)
	item = PileSeller:getID(item)
	if item then
		for i=1, #psItems do
			if item == psItems[i] then return true end
		end
		return false
	end
end

function psEvents:MERCHANT_SHOW(...)
	canTrack = false
	if psSettings["repairSetting"] and CanMerchantRepair() then
		local cost, _c = GetRepairAllCost()
		if cost ~= 0 then
			local g = psSettings["repairGuildSetting"] and CanGuildBankRepair()	and cost <= GetGuildBankWithdrawMoney()	
			RepairAllItems(g)
            local s = "|cFF" .. PileSeller.color .. "Pile|rSeller: Gear repaired for " .. PileSeller:getProfitPerCoin(cost)
			if g then s = s .. " with guild funds" end
            print(s .. ".")
		end
	end
	if #psItems > 0 then
        if not psSettings["confSetting"] then
		  PileSeller.selling = true
        else PileSeller.sellingBox:Show() end
	elseif psSettings["sellJunkSetting"] then
		PileSeller:SellJunk()
	end
end

function PileSeller:SellJunk()
	for i = 0, NUM_BAG_SLOTS do
		for j = 1, GetContainerNumSlots(i) do
			local item = select(7, GetContainerItemInfo(i, j))
			if item then
				local quality = select(3, GetItemInfo(item))
				if quality == 0 then
					ShowMerchantSellCursor(1)
					UseContainerItem(i, j)
				end
			end
		end
	end
end

function PileSeller:ToggleTracking(set)
	if set then 
		if not psSettings["trackSetting"] then
			psSettings["trackSetting"] = true; print("|cFF00FF00Tracking enabled.|r")
			PileSeller:GlowButton(true)
            if PileSeller.UIConfig then
                PileSeller.UIConfig.toggleTracking:SetText("Stop tracking")
            end
		end
	else
		if psSettings["trackSetting"] then
			psSettings["trackSetting"] = false; print("|cFFFF0000Tracking disabled.|r") 
			PileSeller:GlowButton(false)
            if PileSeller.UIConfig then
                PileSeller.UIConfig.toggleTracking:SetText("Start tracking")
            end
		end
	end

end

function psEvents:ZONE_CHANGED_NEW_AREA(...)
	local type = select(2, GetInstanceInfo())
	local t = string.match(type, "raid") or string.match(type, "party")
	local garrison = string.find(GetInstanceInfo(), GARRISON_LOCATION_TOOLTIP)
	local g = IsInGroup()
	if t and not garrison then
		if not g then
			if not psSettings["trackSetting"] then
				StaticPopupDialogs["PS_TOGGLE_TRACKING"] = {
				  text = "Do you wish to track the items in this run?",
				  button1 = "Yes",
				  button2 = "No",
				  OnAccept = function()
				     PileSeller:ToggleTracking(true)
				  end,
				  timeout = 0,
				  whileDead = true,
				  hideOnEscape = true,
				  preferredIndex = 3,
				}
				StaticPopup_Show ("PS_TOGGLE_TRACKING")
			end
		else 
			if psSettings["trackSetting"] and psSettings["showAlertSetting"] then
				StaticPopupDialogs["PS_TOGGLE_TRACKING"] = {
				  text = "Item tracking is active, do you wish to disable it?",
				  button1 = "Yes",
				  button2 = "No",
				  OnAccept = function()
				     PileSeller:ToggleTracking(false)
				  end,
				  timeout = 0,
				  whileDead = false,
				  hideOnEscape = true,
				  preferredIndex = 3,
				}
				StaticPopup_Show ("PS_TOGGLE_TRACKING")
			end
		end
	elseif not t then
		if psSettings["trackSetting"] and psSettings["showAlertSetting"] then
			StaticPopupDialogs["PS_TOGGLE_TRACKING"] = {
				  text = "Item tracking is still active, do you wish to disable it?",
				  button1 = "Yes",
				  button2 = "No",
				  OnAccept = function()
				     PileSeller:ToggleTracking(false)
				  end,
				  timeout = 0,
				  whileDead = false,
				  hideOnEscape = true,
				  preferredIndex = 3,
				}
				StaticPopup_Show ("PS_TOGGLE_TRACKING")
		end
	elseif garrison and psSettings["disableInGarrison"] then
		PileSeller:ToggleTracking(false)
	end
end

function psEvents:GOSSIP_SHOW(...) canTrack = false; end
function psEvents:GOSSIP_CLOSED(...) canTrack = true; end
function psEvents:QUEST_DETAIL(...) canTrack = false; end
function psEvents:QUEST_ACCEPTED(...) canTrack = true; end
function psEvents:MERCHANT_CLOSED(...) canTrack = true; end
function psEvents:MAIL_SHOW(...) canTrack = false end
function psEvents:MAIL_CLOSED(...) canTrack = true end

function psEvents:GET_ITEM_INFO_RECEIVED()
	if waitingForItem[1] then 
		waitingForItem[1] = false 
		PileSeller:addItem(waitingForItem[2], waitingForItem[3])
	end
end

--- Hooking the events ---
psFrame:SetScript("OnEvent", function(self, event, ...)
	psEvents[event](self, ...)
	end)
for k, v in pairs(psEvents) do
	psFrame:RegisterEvent(k)
end
--------------------------

function PileSeller:addItem(item, list, scroll)
	local i = select(2, GetItemInfo(item)) 
	if not i then
		waitingForItem[1] = true
		waitingForItem[2] = item
        waitingForItem[3] = list
	else 
		list[#list + 1] = PileSeller:getID(i)
        if scroll then
            PileSeller:PopulateList(scroll, list)
            PileSeller.UIConfig.txtAddSavedItem:SetText("")
        end
	end
end

function PileSeller:removeItem(link, list, scroll)
    local id = PileSeller:getID(link)
    for i=0, #list do
        if list[i] == id then 
            tremove(list, i)
            if PileSeller.UIConfig then
                if PileSeller.UIConfig:IsShown() and scroll then
                    PileSeller:PopulateList(scroll, list)
                    PileSeller:CreateItemsSection(PileSeller.UIConfig)
                end
            elseif PileSeller.sellingBox:IsShown() and scroll then
                PileSeller:PopulateList(scroll, list)
            end
            --local tmp = list == psItems and "selling" or "saving"
            --print(select(2, GetItemInfo(link)) .. " removed from the item " .. tmp .. " list.") 
            return
        end
    end
end

--[[ Function to get the item's ID from a link ]]--
function PileSeller:getID(item)
	local item = string.match(item, "item[%-?%d:]+") -- This is something like "item:7073:0:0:0:0:0:0:0:80:0:0:0:0"
	if #item > string.len("item:0000") then
		item = string.sub(item, 6) -- Now I have 7073:0:0:0:0:0:0:0:80:0:0:0:0

		i = 1
		current = item:sub(0,0)
		id = ""
		--print(current)
		while current ~= ":" do
			id = id .. item:sub(i,i)
			i = i + 1
			current = item:sub(i,i)
		end
		return id
	else return nil end
end

function PileSeller:isSaved(item)
	for i=1, #psItemsSaved do
		if(item == psItemsSaved[i]) then
			psItemsSavedFound[item] = true
			return true
		end
	end
	return false
end


-- Hook the bags buttons
function linkFromContainer(button)
	if PileSeller.UIConfig then
		if IsShiftKeyDown() and PileSeller.UIConfig:IsShown() then
			if PileSeller.UIConfig.txtAddSavedItem:HasFocus() then
				PileSeller.UIConfig.txtAddSavedItem:SetText(GetContainerItemLink(button:GetParent():GetID(), button:GetID()))
			end
		end
	end
end
hooksecurefunc("ContainerFrameItemButton_OnModifiedClick", linkFromContainer)

-- Hook the links from chat
function linkFromChatFrame(self, link, text, button)
	if PileSeller.UIConfig then
		if IsShiftKeyDown() and PileSeller.UIConfig:IsShown() then
			if PileSeller.UIConfig.txtAddSavedItem:HasFocus() then
				local item =  PileSeller:getID(link)
				item = select(2, GetItemInfo(item))
				PileSeller.UIConfig.txtAddSavedItem:SetText(item)
			end
		end
	end
end
hooksecurefunc("ChatFrame_OnHyperlinkShow", linkFromChatFrame)

-- Hook the encounter
function EncounterJournal_Show()
    local originalM = EncounterJournal_Loot_OnClick
    EncounterJournal_Loot_OnClick = function(self, elapsed)
        if PileSeller.UIConfig then
            if IsShiftKeyDown() and PileSeller.UIConfig:IsShown() then
                if PileSeller.UIConfig.txtAddSavedItem:HasFocus() then
                    PileSeller.UIConfig.txtAddSavedItem:SetText(self.link)
                end
            end
        end
    end 
end
hooksecurefunc("EncounterJournal_LoadUI", EncounterJournal_Show)

SLASH_PILESELLER1 = "/pileseller"
SLASH_PILESELLER2 ="/ps"

function SlashCmdList.PILESELLER(msg, editbox)
	if msg == "" then
		print("PileSeller arguments")
		print("|cFF" .. PileSeller.color .. "config|r|||cFF" .. PileSeller.color .. "items|r - open config or session window")
		print("|cFF" .. PileSeller.color .. "start|r - start a new session")
		print("|cFF" .. PileSeller.color .. "stop|r - stop the current session")
        print("|cFF" .. PileSeller.color .. "additem|r - adds an item to the saved list")
        print("|cFF" .. PileSeller.color .. "removeitem|r - removes and item from the saved list")
        print("|cFF" .. PileSeller.color .. "removesell|r - removes an item from the selling list")
	else
		if msg == "config" or msg == "items" then
			PileSeller:ShowConfig(msg)
		elseif string.match(msg, "additem ") then
            local s = string.gsub(msg, "additem ", "")
            if s then
                if string.match(s, "item[%-?%d:]+") then
                    PileSeller:addItem(s, psItemsSaved)
                end
            end
        elseif string.match(msg, "removeitem ") then
            local s = string.gsub(msg, "removeitem  ", "")
            if s then
                if string.match(s, "item[%-?%d:]+") then
                    PileSeller:removeItem(s, psItemsSaved, nil)
                end
            end
        elseif string.match(msg, "removesell ") then
            local s = string.gsub(msg, "removesell  ", "")
            if s then
                if string.match(s, "item[%-?%d:]+") then
                    PileSeller:removeItem(s, psItems, nil)
                end
            end
        elseif msg == "start" then
            PileSeller:ToggleTracking(true)
        elseif msg == "stop" or msg == "end" then
            PileSeller:ToggleTracking(false)
        end 
	end
end